package patrones.visitor.ej1;

public class ClienteMain {

	public static void main(String[] args) {
		// CREAR LA ORDEN

		// get input values
		String orderType = "CALIFORNIA"; //Puede ser tambien: NON-CALIFORNIA, OVERSEAS
		double dblOrderAmount = 100;
		double dblTax = 10;
		double dblSH = 2.0;

		// Create the order
		Order order = createOrder(orderType, dblOrderAmount, dblTax, dblSH);
		// Get the Visitor
		OrderVisitor visitor = new OrderVisitor();
		// accept the visitor instance
		order.accept(visitor);
		System.out.println("Order Created Successfully");

		// OBTENER EL TOTAL
		double totalResult = visitor.getOrderTotal();
		System.out.println(" Orders Total = " + totalResult);

	}

	public static Order createOrder(String orderType, double orderAmount,
			double tax, double SH) {
		if (orderType.equalsIgnoreCase("CALIFORNIA")) {
			return new CaliforniaOrder(orderAmount, tax);
		}
		if (orderType.equalsIgnoreCase("NON-CALIFORNIA")) {
			return new NonCaliforniaOrder(orderAmount);
		}
		if (orderType.equalsIgnoreCase("OVERSEAS")) {
			return new OverseasOrder(orderAmount, SH);
		}
		return null;
	}
}
